#!/bin/bash
#############################################################
#
# the mighty PERPLEX crew presents
# 
# MP3 Unrar v0.3 for glftpd
#
#
#
# HOWTO: RAR a complete Release (just the files).
#        To Unrar it on a site use site unrar. 
#
#
# Script Needs: "mp3info (http://www.ibiblio.org/mp3info),
#                unrar (www.rarlab.com),
#                awk, cat, du, echo, expr, grep, ls, rm, sed, touch, wc" in /bin dir
#
# Add this to glftpd.conf:
#
#      site_cmd UNRAR          EXEC    /bin/unrar.sh
#      custom-unrar            1 =LAMERS
#
# NOTE: MP3 Unrar v0.3 doesn't work with id3v2 Tags
#
####################################################
#                                                 #
#           USING AT OWN RISK                    #
#                                               #
################################################
#
### CONFIGURATION ###
#
# sitename
siteshort="MSN"
#
# directory where rar files are stored
sitedir="/site/change_this/*"
#
# INcomplete string for ISO (rar)
rarstring="_INCOMPLETE_"
#
# filename where releaseinfos are stored (e.g. .message)
infofile=".message"
#
#
#
######### DONT TOUCH ANYTHING BELOW UNLESS YOU KNOW WHAT YOU ARE DOING ##########
#
#
#
# Starting now
#
# get local dir
localdir=`pwd`

# get the sfv file name with the rar files
sfvfile=`ls | grep -i "\.sfv$"`

echo "[--- --  - PPX Presents MP3 UNRAR - --]"

case `pwd` in
	$sitedir)
	echo "[$siteshort] Start extracting files ..."

	#check if the release is complete
	if [ -d $rarstring ]; then
		echo "[$siteshort] Sorry the Release is not Complete ... "
		echo "[$siteshort] Please Complete it and run it again."
		exit
	fi

	#find the first rar file
	if `ls *.part01.rar> /dev/null 2>&1`; then
        	rarfile=`ls *.part01.rar`
	else
                if `ls *.part1.rar> /dev/null 2>&1`; then
        	        rarfile=`ls *.part1.rar`
	        else
                        if `ls *.rar> /dev/null 2>&1`; then
        	                rarfile=`ls *.rar`
	                else
        	                if `ls *.r00 > /dev/null 2>&1`; then
                	                rarfile=`ls *.r00`
	                        else
        	                        if `ls *.r01 > /dev/null 2>&1`; then
                	                        rarfile=`ls *.r01`
	                                else
        	                                if `ls *.001 > /dev/null 2>&1`; then
                	                                rarfile=`ls *.001`
                        	                else
					                echo "[$siteshort] Sorry we found no rar file."
					                echo "[$siteshort] Please conntact the siteop."
					                exit
                                                fi
                                        fi
				fi
                	fi
        	fi
	fi

	#delete the old nfo file
	rm *.nfo > /dev/null 2>&1

	#extract the rar's
	/bin/unrar x -inul $rarfile > /dev/null
	if [ ! $? -eq 0 ] ; then
		echo "[$siteshort] Problems during unrar the files ..."
		echo "[$siteshort] Please contact the siteop."
		exit
	fi

	# delete the rar files and the old sfv file
	for x in `grep -v ";" $sfvfile | grep -v "#" | sed 's/ .*//'` ; do
		rm $x
	done
	rm $sfvfile > /dev/null 2>&1
	rm $infofile > /dev/null 2>&1
	rm -rf "[$siteshort]_NFO_MISSING_[$siteshort]" > /dev/null 2>&1
	rm $localdir/*[$siteshort]*[$siteshort]* > /dev/null 2>&1

	#make a genre file and so on ...
	mp3file=`/bin/ls *.[mM][pP][3] | head -1`
	Year=`/bin/mp3info -p "%y\n%g\n%r\n" "$mp3file" | head -1`
	if [ -z $Year ] ; then
        	Year="None"
	fi
	Genre=`/bin/mp3info -p "%y\n%g\n%r\n" "$mp3file" | tail -2 | head -1`
	Bitrate=`/bin/mp3info -p "%y\n%g\n%r\n" "$mp3file" | tail -1`	
	/bin/touch "$localdir/-[$siteshort]- Year:$Year Genre:$Genre Bitrate:"$Bitrate"kbit -[$siteshort]-"
	size=0
	for x in `/bin/du -k *.[mM][pP][3] | /bin/cut -f1` ; do
        	size=`/bin/expr $size + $x`
	done
	if [ $size -gt 1024 ] ; then
        	size=`/bin/expr $size / 1024`"mB"
	else
        	size=$size"kB"
	fi
	sfvfiles=`/bin/cat *.[sS][fF][vV] | /bin/grep -v ";" | /bin/awk '{print $1}' | /bin/grep [mM][pP][3] | /bin/wc -l | /bin/awk '{print $1}'`
	/bin/touch "$localdir/-[$siteshort]- $sfvfiles Completed Files in ${size} -[$siteshort]-"
	echo "[$siteshort] Extracting done."
;;
*)
	echo "[$siteshort] Sorry you are in the wrong directory to use this command."
esac

